=== debian/changelog ===
fpgatools (0.0+201212-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061945

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:08:25 +0000

fpgatools (0.0+201212-1) unstable; urgency=low

  * New snapshot, taken from commit f4b5b89
  * Initial release. (Closes: #686949)

 -- Xiangfu Liu <xiangfu@openmobilefree.net>  Tue, 14 Aug 2012 10:03:41 +0800
