=== debian/control ===
Source: fpgatools
Section: electronics
Priority: extra
Maintainer: Xiangfu Liu <xiangfu@openmobilefree.net>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 9), dpkg-dev (>= 1.16.1~),
 bash (>= 4), chrpath (>= 0.13)
Standards-Version: 3.9.4
DM-Upload-Allowed: yes
Homepage: https://github.com/Wolfgang-Spraul/fpgatools
Vcs-Git: git://github.com/Wolfgang-Spraul/fpgatools.git
Vcs-Browser: https://github.com/Wolfgang-Spraul/fpgatools

Package: libfpga0t64
Provides: ${t64:Provides}
Replaces: libfpga0
Breaks: libfpga0 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries of fpgatools
 fpgatools is a toolchain to program field-programmable gate arrays
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.
 .
 This package provides a shared library for small independent
 command line utilities contributing to the fpgatools.
  * plain C, no C++
  * simple Makefiles
  * text-based file formats
  * automatic test suite

Package: libfpga-dev
Architecture: any
Section: libdevel
Depends: libfpga0t64 (= ${binary:Version}), ${misc:Depends}
Description: development files for fpgatools
 fpgatools is a toolchain to program field-programmable gate arrays
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.
 .
 This package contains headers and libraries for developing bits file 
 that makes use of libfpga.

Package: fpgatools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfpga0t64 (= ${binary:Version})
Description: tool to program field-programmable gate arrays
 fpgatools is a toolchain to program field-programmable gate array
 (FPGA).  The only supported chip at this time is the xc6slx9, a cheap
 but powerful 45nm-generation chip with about 2400 LUTs, block ram and
 multiply-accumulate devices.
