=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	$(MAKE) fp2bit bit2fp

override_dh_auto_clean:
	$(MAKE) clean
	sh debian/clean.sh

override_dh_installchangelogs:
	dpkg-parsechangelog --format rfc822 --all | \
		awk -f debian/changelog.upstream.awk
	dh_installchangelogs debian/changelog.upstream

# Remove auto test for fast develop
# will include auto_test in the end
override_dh_auto_test:

REPO = git://github.com/Wolfgang-Spraul/fpgatools.git
BRANCH = master
get-orig-source:
	REPO='$(REPO)' BRANCH='$(BRANCH)' \
		sh ./debian/get-orig-source.sh
